// $Id: test_data_ivec.c,v 1.5 2017/03/20 13:15:58 leavens Exp $
#include <stdio.h>
#include "test_data_ivec.h"
// data for testing ivecs
int v0[1];    /* {0} */
int v1[2];    /* {1, 0} */
int v3223[5]; /* {3, 2, 2, 3, 0} */
int v3123[5]; /* {3, 1, 2, 3, 0} */
int v2123[5]; /* {2, 1, 2, 3, 0} */
int v3323[5]; /* {3, 3, 2, 3, 0} */
int v3224[5]; /* {3, 2, 2, 4, 0} */
int v3221[5]; /* {3, 2, 2, 1, 0} */
int v3223ext[9]; /* {3, 2, 2, 3, 0, 5, 7, 0, 99} */
int vucf[9];     /* {8, 2, 3, 0, 4, 7, 5, 8, 0} */
int vto100[VTO100_SIZE];  /* {1, 2, ..., 99, 100, 0} */

// assigns: all of the elements of all of the arrays above
// effect: (re)initialize the test data arrays
void init_test_data() {
    v0[0] = 0;
    v1[0] = 1; v1[1] = 0;
    v3223[0] = 3; v3223[1] = 2; v3223[2] = 2; v3223[3] = 3; v3223[4] = 0;
    v3123[0] = 3; v3123[1] = 1; v3123[2] = 2; v3123[3] = 3; v3123[4] = 0;
    v2123[0] = 2; v2123[1] = 1; v2123[2] = 2; v2123[3] = 3; v2123[4] = 0;
    v3323[0] = 3; v3323[1] = 3; v3323[2] = 2; v3323[3] = 3; v3323[4] = 0;
    v3224[0] = 3; v3224[1] = 2; v3224[2] = 2; v3224[3] = 4; v3224[4] = 0;
    v3221[0] = 3; v3221[1] = 2; v3221[2] = 2; v3221[3] = 1; v3221[4] = 0;    
    v3223ext[0] = 3; v3223ext[1] = 2; v3223ext[2] = 2; v3223ext[3] = 3;
    v3223ext[4] = 0; v3223ext[5] = 5; v3223ext[6] = 7; v3223ext[7] = 0; v3223ext[8] = 99;
    vucf[0] = 8; vucf[1] = 2; vucf[2] = 3; vucf[3] = 0;
    vucf[4] = 4; vucf[5] = 7; vucf[6] = 5; vucf[7] = 8; vucf[8] = 0;
    for (int i = 0; i < VTO100_SIZE; i++) {
	vto100[i] = i+1;
    }
    vto100[VTO100_SIZE-1] = 0;
}

/* requires: value and expected have at least sz elements
   effect: When the result is false, prints debugging information 
           about the two arrays on stdout. */
static void print_debug_info(const int value[], const int expected[], int sz) {
    for (int j = 0; j < sz; j++) {
	if (value[j] == expected[j]) {
	    printf("value[%d] == %d == expected[%d]\n", j, value[j], j);
	} else {
	    printf("value[%d] == %d but expected[%d] == %d\n",
		   j, value[j], j, expected[j]);
	}
    }
}

/* requires: value and expected have at least sz elements
   ensures: result is true just when the first sz elements of value
            are equal to the first sz elements of expected, i.e.,
	    the result is true just when
               for all i such that 0 <= i < sz, value[i] == expected[i].
   effect: When the result is false, prints the two arrays on stdout. */
bool array_equals(const int value[], const int expected[], int sz) {
    for (int i = 0; i < sz; i++) {
	if (value[i] != expected[i]) {
	    print_debug_info(value, expected, sz);
	    return false;
	}
    }
    return true;
}
