// $Id: test_is_member.c,v 1.3 2017/04/02 19:01:08 leavens Exp leavens $
// Compile with:
// gcc tap.c is_member.c test_data_string_sets.c test_is_member.c -o test_is_member
#include <stdbool.h>
#include "tap.h"
#include "test_data_string_sets.h"

extern bool is_member(const char *sought, const char * const strs[],
   	              const int strs_sz);

// testing for is_member()
int main() {
    // for some reason, not calling plan() makes the tests effective
    // against implementations of is_member that don't return anything...
    // plan(11);
    ok(!is_member("foo", s1, 1), "!is_member(\"foo\", s1, 1)");
    ok(is_member("hello", s1, 1) == true, "is_member(\"hello\", s1, 1)");
    ok(is_member("frank", s1, 1) == false, "!is_member(\"frank\", s1, 1)");
    ok(is_member("", s1, 1) == false, "!is_member(\"\", s1, 1)");
    ok(is_member("abbey", s5, 5) == true, "is_member(\"abbey\", s5, 5)");
    ok(is_member("today", s5, 5) == true, "is_member(\"today\", s5, 5)");
    ok(is_member("Today", s5, 5) == false, "!is_member(\"Today\", s5, 5)");
    ok(is_member("Python", s5, 5) == false, "!is_member(\"Python\", s5, 5)");
    ok(is_member("relations", Ada_Lovelace_quote, LLQ_LENGTH) == true,
       "is_member(\"relations\", Ada_Lovelace_quote, LLQ_LENGTH)");
    ok(is_member("the", Ada_Lovelace_quote, LLQ_LENGTH) == true,
       "is_member(\"the\", Ada_Lovelace_quote, LLQ_LENGTH)");
    ok(is_member("UCF", Ada_Lovelace_quote, LLQ_LENGTH) == false,
       "!is_member(\"UCF\", Ada_Lovelace_quote, LLQ_LENGTH)");
    return exit_status();
}
