// $Id: test_ivec_add.c,v 1.8 2017/04/01 13:23:00 leavens Exp leavens $
// Compile with:
// gcc tap.c ivec_len.c ivec_add.c test_data_ivec.c test_ivec_add.c -o test_ivec_add
#include "tap.h"
#include "ivec_add.h"

// declarations of test data (see test_data_ivec.c) used below
#include "test_data_ivec.h"

// testing for ivec_add().
int main() {
    plan(7);
    int v[] = {9, 7, 8, 6, 9, 0, 5, 4, 0};
    int c[] = {3, 5, 7, 4, 1, 6, 0, 0, 7};
    ivec_add(v, c);
    int vans[] = {12, 12, 15, 10, 10, 0, 5, 4, 0};
    ok(array_equals(v, vans, 9), "v = v + c");

    // using test data from ivec_test_data.c below...
    init_test_data();

    int vempty[] = {0};
    int v0a[] = {0};
    ivec_add(vempty, vempty);
    ok(array_equals(vempty, v0a, 1), "vempty = vempty + vempty");

    int v0ans[] = {0};
    ivec_add(v0, v1);
    ok(array_equals(v0, v0ans, 1), "v0 = v0 + v1");

    int v3223ans[] = {6, 3, 4, 6, 0};
    ivec_add(v3223, v3123);
    ok(array_equals(v3223, v3223ans, 5), "v3223 = v3223 + v3123");

    int v100[] = {100, 100, 100, 100, 0};
    int v3123ans[] = {102, 101, 102, 103, 0};
    ivec_add(v2123, v100);
    ok(array_equals(v2123, v3123ans, 5), "v2123 = v2123 + v100");

    int vucfans[] = {11, 4, 5, 0, 4, 7, 5, 8, 0};
    ivec_add(vucf, v3223ext);
    ok(array_equals(vucf, vucfans, 9), "vucf += v3223ext");
  
    int vto100by2[VTO100_SIZE];
    for (int i = 0; i < VTO100_SIZE-1; i++) {
	vto100by2[i] = 2*(i+1);
    }
    vto100by2[VTO100_SIZE-1] = 0;
    ivec_add(vto100, vto100);
    ok(array_equals(vto100, vto100by2, VTO100_SIZE), "vto100 += vto100");
    return exit_status();
}
