// $Id: test_ivec_cmp.c,v 1.6 2017/04/01 19:22:59 leavens Exp leavens $
// Compile with:
// gcc tap.c ivec_len.c ivec_cmp.c test_data_ivec.c test_ivec_cmp.c -o test_ivec_cmp

#include "tap.h"
#include "ivec_cmp.h"

// declarations of test data (see test_data_ivec.c) used below
#include "test_data_ivec.h"

// testing for ivec_cmp().
int main() {
    plan(27);
    int v[] = {9, 7, 8, 6, 9, 0, 5, 4, 0};
    ok(ivec_cmp(v, v) == 0, "ivec_cmp(v, v) == 0");
    int w[] = {10, 8, 0};  // tests involving w and x are new
    ok(ivec_cmp(v, w) == -1, "ivec_cmp(v, w) == +1");
    ok(ivec_cmp(w, v) == +1, "ivec_cmp(v, w) == +1");
    int x[] = {10, 8, -9, 0};
    ok(ivec_cmp(w, x) == -1, "ivec_cmp(w, x) == -1");
    ok(ivec_cmp(x, w) == +1, "ivec_cmp(x, w) == +1");
    // using test data from ivec_test_data.c below
    init_test_data();
    ok(ivec_cmp(v0, v0) == 0, "ivec_cmp(v0) == 0");
    ok(ivec_cmp(v0, v1) == -1, "ivec_cmp(v0, v1) == -1");
    ok(ivec_cmp(v1, v0) == +1, "ivec_cmp(v1, v0) == +1");
    ok(ivec_cmp(v1, v1) == 0, "ivec_cmp(v1, v1) == 0");
    ok(ivec_cmp(v1, v3223) == -1, "ivec_cmp(v1, v3223) == -1");
    ok(ivec_cmp(v3223, v1) == +1, "ivec_cmp(v3223, v1) == +1");
    ok(ivec_cmp(v3223, v3223) == 0, "ivec_cmp(v3223, v3223) == 0");
    ok(ivec_cmp(v3223, v3123) == +1, "ivec_cmp(v3223, v3123) == +1");
    ok(ivec_cmp(v3123, v3223) == -1, "ivec_cmp(v3123, v3223) == -1");
    ok(ivec_cmp(v3223, v2123) == +1, "ivec_cmp(v3223, v2123) == +1");
    ok(ivec_cmp(v2123, v3223) == -1, "ivec_cmp(v2123, v3223) == -1");
    ok(ivec_cmp(v3223, v3323) == -1, "ivec_cmp(v3223, v3323) == -1");
    ok(ivec_cmp(v3323, v3223) == +1, "ivec_cmp(v3323, v3223) == +1");
    ok(ivec_cmp(v3323, v3224) == +1, "ivec_cmp(v3323, v3224) == +1");
    ok(ivec_cmp(v3224, v3323) == -1, "ivec_cmp(v3224, v3323) == -1");
    ok(ivec_cmp(v3223, v3223ext) == 0, "ivec_cmp(v3223, v3223ext) == 0");
    ok(ivec_cmp(v3223ext, v3223) == 0, "ivec_cmp(v3223ext, v3223) == 0");
    ok(ivec_cmp(v0, vucf) == -1, "ivec_cmp(v0, vucf) == -1");
    ok(ivec_cmp(vucf, v0) == +1, "ivec_cmp(vucf, v0) == +1");
    ok(ivec_cmp(vto100, vto100) == 0, "ivec_cmp(vto100, vto100) == 0");
    int u2[] = {0, 1, 2, 0};
    ok(ivec_cmp(u2, vto100) == -1, "ivec_cmp(u2, vto100) == -1");
    ok(ivec_cmp(vto100, u2) == +1, "ivec_cmp(vto100, u2) == +1");
    return exit_status();
}
