// $Id: test_ivec_scalar_mult.c,v 1.6 2017/03/20 13:15:58 leavens Exp $
// Compile with:
// gcc tap.c ivec_len.c ivec_scalar_mult.c test_data_ivec.c test_ivec_scalar_mult.c -o test_ivec_scalar_mult
#include <stdbool.h>
#include "tap.h"
#include "ivec_scalar_mult.h"
// declarations of test data (see test_data_ivec.c) and array_equals used below
#include "test_data_ivec.h"

// testing for ivec_scalar_mult().
int main() {
    plan(10);
    int v[] = {9, 7, 8, 6, 9, 0, 5, 4, 0};
    ivec_scalar_mult(v, 10);
    int vans[] = {90, 70, 80, 60, 90, 0, 5, 4, 0};
    ok(array_equals(v, vans, 9), "scalar_mult of v is vans");
    // using test data from ivec_test_data.c below...
    init_test_data();

    int v0ans[] = {0};
    ivec_scalar_mult(v0, 934);
    ok(array_equals(v0, v0ans, 1), "scalar mult of v0 by 934");

    int v1ans[] = {55, 0};
    ivec_scalar_mult(v1, 55);
    ok(array_equals(v1, v1ans, 2), "scalar mult of v1 by 55");

    int v3223ans[] = {6, 4, 4, 6, 0};
    ivec_scalar_mult(v3223, 2);
    ok(array_equals(v3223, v3223ans, 5), "scalar mult of v3223 by 2");

    int v3123ans[] = {9, 3, 6, 9, 0};
    ivec_scalar_mult(v3123, 3);
    ok(array_equals(v3123, v3123ans, 5), "scalar mult of v3123 by 2");

    int v2123ans[] = {200, 100, 200, 300, 0};
    ivec_scalar_mult(v2123, 100);
    ok(array_equals(v2123, v2123ans, 5), "scalar mult of v2123 by 100");

    int v3223extans[] = {150, 100, 100, 150, 0, 5, 7, 0, 99};
    ivec_scalar_mult(v3223ext, 50);
    ok(array_equals(v3223ext, v3223extans, 9), "scalar mult of v3223ext by 50");

    int v3223extans2[] = {300, 200, 200, 300, 0, 5, 7, 0, 99};
    ivec_scalar_mult(v3223ext, 2);
    ok(array_equals(v3223ext, v3223extans2, 9), "scalar mult of v3223ext by 2");
  
    int vucfans[] = {48, 12, 18, 0, 4, 7, 5, 8, 0};
    ivec_scalar_mult(vucf, 6);
    ok(array_equals(vucf, vucfans, 9), "scalar mult of vucf by 6");

    int zeros[VTO100_SIZE]; // all zeros
    for (int i = 0; i < VTO100_SIZE; i++) {
	zeros[i] = 0;
    }
    ivec_scalar_mult(vto100, 0);
    ok(array_equals(vto100, zeros, VTO100_SIZE), "scalar mult of vto100 by 0");
    return exit_status();
}
