// $Id: test_no_dups.c,v 1.4 2017/04/02 22:10:03 leavens Exp leavens $
// Compile with:
// gcc tap.c test_data_string_sets.c is_member.c no_dups.c test_no_dups.c -o test_no_dups
#include <stdbool.h>
#include "tap.h"
#include "test_data_string_sets.h"
#include "no_dups.h"

// testing for is_no_dups()
int main() {
    // plan(5);
    const char *const sset0[1] = {""};
    const char *const sset[] = {"Now", "is", "the", "time"};
    const char *const sset2[] = {"Now", "is", "the", "time", "yes:", "Now"};
    // create an array sset3 that doesn't have just literals in it...
    char str1[4]; char str2[4];
    str1[0] = 'N'; str1[1] = 'o'; str1[2] = 'w'; str1[3] = '\0';
    str2[0] = 'N'; str2[1] = 'o'; str2[2] = 'w'; str2[3] = '\0';
    const char *const sset3[3] = {str1, "Spacer", str2};
    const char *const sset4[3] = {"Spacer", str1, str2};
    ok(no_dups(sset0, 0), "no_dups(sset0, 0)");
    ok(no_dups(sset0, 1), "no_dups(sset0, 1)");
    ok(no_dups(sset, 4), "no_dups(sset, 4)");
    ok(!no_dups(sset2, 6), "!no_dups(sset2, 6)");
    ok(!no_dups(sset3, 3), "!no_dups(sset3, 3)");
    ok(!no_dups(sset4, 3), "!no_dups(sset4, 3)");
    // the following use test data from test_data_string_sets.c
    ok(no_dups(s1, 1), "no_dups(s1, 1)");
    ok(no_dups(s5, 5), "no_dups(s5, 5)");
    ok(!no_dups(Ada_Lovelace_quote, LLQ_LENGTH), "!no_dups(Ada_Lovelace_quote, LLQ_LENGTH)");
    return exit_status();
}
